/**
 * @class demo1
 * @package window
 * @author Sebsatian Widelak
 */
var demo1 = (function (window, undefined) {
    var
        /**
         * Easel
         */
        Stage = createjs.Stage,
        Text = createjs.Text,
        Bitmap = createjs.Bitmap,
        Ticker = createjs.Ticker,
        /***
         * Box2D
         */
        b2Vec2 = Box2D.Common.Math.b2Vec2,
        b2BodyDef = Box2D.Dynamics.b2BodyDef,
        b2Body = Box2D.Dynamics.b2Body,
        b2FixtureDef = Box2D.Dynamics.b2FixtureDef,
        b2Fixture = Box2D.Dynamics.b2Fixture,
        b2World = Box2D.Dynamics.b2World,
        b2MassData = Box2D.Collision.Shapes.b2MassData,
        b2PolygonShape = Box2D.Collision.Shapes.b2PolygonShape,
        b2CircleShape = Box2D.Collision.Shapes.b2CircleShape,
        b2DebugDraw = Box2D.Dynamics.b2DebugDraw,
        /**
         * Const
         */
            DEBUG = false, //true jezeli chcemy widziec obiekty Box2D
        SCALE = 30, //w Box2D jednostka podstawowa sa metry
        FRAMERATE = 60, //ilosc klatek na sekunde
        WIDTH,// szerokosc, automatycznie ustawiana
        HEIGHT,// wysokosc, automatycznie ustawiana
        canvas, //canvas glowny
        canvas2, //canvas dla Box2D (do debagowania)
        halt = 0, //kontener dla id intervala (gracz 1)
        halt2 = 0, //kontener dla id intervala (gracz 2)
        stage, // kontener dla objektu easeljs (scena)
        world, // object Box2D
        a, //
        b, // gracz 1
        b2, // gracz 2
        c,// pilka
        g1, // bramka 1
        g2, // bramka 2
        team1res,
        team2res;

    window.world = world;
    /**
     * ustawiamy wlasciwosci fizyki
     */
    function setupPhysics() {
        /**
         *  definicja wlasciwosci (sciany)
         */
        var fixDef = {
                t: new b2FixtureDef, // sciana gorna
                r: new b2FixtureDef, // sciana prawa
                d: new b2FixtureDef, // sciana dolna
                l: new b2FixtureDef // sciana lewa
            },
            /**
             *
             */
                bodyDef = {
                t: new b2BodyDef,
                r: new b2BodyDef,
                d: new b2BodyDef,
                l: new b2BodyDef
            },
            debug = new b2DebugDraw;
        /**
         * Tworzymy nowy swiat, podajemy wektor poczatkowy (brak grawitacji), pozwalamy na "usypianie" obiektow
         * @type {Box2D.Dynamics.b2World}
         */
        world = new b2World(new b2Vec2(0, 0), true);
        /**
         * Gestosc (kg/m^2)
         * @type {number}
         */
        fixDef.t.density = .1;
        fixDef.d.density = .1;
        fixDef.r.density = 1;
        fixDef.l.density = 1;
        /**
         * wspolczynnik tarcia
         * @type {number}
         */
        fixDef.t.friction = .1;
        fixDef.d.friction = .1;
        fixDef.r.friction = .1;
        fixDef.l.friction = .1;
        /**
         * Ustawiamy typ ciala
         * @type {*}
         */
        bodyDef.t.type = b2Body.b2_staticBody;
        bodyDef.d.type = b2Body.b2_staticBody;
        bodyDef.r.type = b2Body.b2_staticBody;
        bodyDef.l.type = b2Body.b2_staticBody;
        /**
         * Body definition
         * punktem poczatkowy dla b2D jest srodek
         * @type {number}
         */
        bodyDef.t.position.x = WIDTH / SCALE;
        bodyDef.t.position.y = 0;
        bodyDef.d.position.x = WIDTH / SCALE;
        bodyDef.d.position.y = HEIGHT / SCALE;
        bodyDef.r.position.x = (WIDTH) / SCALE;
        bodyDef.r.position.y = 0 / SCALE;
        bodyDef.l.position.x = 0 / SCALE;
        bodyDef.l.position.y = HEIGHT / SCALE;
        /**
         * Shape
         * @type {Box2D.Collision.Shapes.b2PolygonShape}
         */
        fixDef.t.shape = new b2PolygonShape();
        fixDef.d.shape = new b2PolygonShape();
        fixDef.r.shape = new b2PolygonShape();
        fixDef.l.shape = new b2PolygonShape();

        fixDef.t.shape.SetAsBox(WIDTH / SCALE, 5 / SCALE);
        fixDef.d.shape.SetAsBox(WIDTH / SCALE, 5 / SCALE);
        fixDef.r.shape.SetAsBox(5 / SCALE, HEIGHT / SCALE);
        fixDef.l.shape.SetAsBox(5 / SCALE, HEIGHT / SCALE);
        /**
         * Join everything
         */
        world.CreateBody(bodyDef.t).CreateFixture(fixDef.t);
        world.CreateBody(bodyDef.d).CreateFixture(fixDef.d);
        world.CreateBody(bodyDef.r).CreateFixture(fixDef.r);
        world.CreateBody(bodyDef.l).CreateFixture(fixDef.l);
        /**
         * Debug
         */
        debug.SetSprite(canvas2.getContext('2d'));
        debug.SetDrawScale(SCALE);
        debug.SetFillAlpha(0.5);
        debug.SetFlags(b2DebugDraw.e_shapeBit | b2DebugDraw.e_jointBit);
        world.SetDebugDraw(debug);
    }

    /**
     * definiujemy co bedziemy robic co kazdy cykl
     */
    function tick() {
        /**
         * Uaktualnij scene
         */
        stage.update();
        /**
         * Jezeli wlaczony tryb debugowania, pokaz objekt Box2D
         */
        if (DEBUG)
            world.DrawDebugData();
        /**
         * Wykonaj kolejne obliczenia fizyki
         */
        world.Step(1 / FRAMERATE, 10, 10);
        /**
         * Wyczysc sily
         */
        world.ClearForces();
    }

    return {
        init: function () {
            canvas = document.getElementById('canvas');
            canvas2 = document.getElementById('debug');
            WIDTH = canvas.width;
            HEIGHT = canvas.height;
            stage = new Stage(canvas);
            team1res = document.getElementById('team1');
            team2res = document.getElementById('team2');
            /**
             * Przygotuj fizyke
             */
            setupPhysics();
            /**
             * Borders
             * @type {Border}
             */
            a = new Border(WIDTH, HEIGHT, "green");
            /**
             * Player one
             * @type {Player}
             */
            b = new Player('img/p1.png', world, SCALE);
            /**
             * Player two
             * @type {Player}
             */
            b2 = new Player('img/p2.png', world, SCALE);
            /**
             * Ball
             * @type {Circle}
             */
            c = new Circle('img/pilka.png', world, SCALE);
            g1 = new Goal('team1', WIDTH - 10, (HEIGHT - 50) / 2, world, SCALE);
            g2 = new Goal('team2', 0, (HEIGHT - 50) / 2, world, SCALE);

            world.SetContactListener({
                BeginContact: function (contact) {
                    switch (contact.m_fixtureA.m_body.element_type) {
                        case 'Goal' :
                        {
                            if (contact.m_fixtureB.m_body.element_type === 'Ball') {
                                switch (contact.m_fixtureA.m_body.element_id) {
                                    case 'team1' :
                                    {
                                        team1res.innerHTML = parseInt(team1res.innerHTML) + 1;
                                        break;
                                    }
                                    case 'team2' :
                                    {
                                        team2res.innerHTML = parseInt(team2res.innerHTML) + 1;
                                        break;
                                    }
                                }
                            }
                            break;
                        }
                    }
                },
                PreSolve: function () {
                },
                PostSolve: function () {
                },
                EndContact: function (contact) {
                }
            });

            stage.addChild(a.view);
            stage.addChild(b.view);
            stage.addChild(b2.view);
            stage.addChild(c.view);
            stage.addChild(g1.view);
            stage.addChild(g2.view);
            document.onkeydown = function (e) {
                if (e.keyIdentifier == 'U+0020') {
                    if (!halt) {
                        b.halt();
                        halt = setInterval(function () {
                            b.halt();
                        }, 50);
                    }
                    e.preventDefault();
                    return;
                }


                if (typeof b.dir[e.keyIdentifier] !== 'undefined') {
                    b.setDir(e.keyIdentifier, true);
                    e.preventDefault();
                    return;
                }


                /**
                 * Player 2
                 */
                if (e.keyIdentifier == 'Shift') {
                    if (!halt2) {
                        b2.halt();
                        halt2 = setInterval(function () {
                            b2.halt();
                        }, 50);
                    }
                    e.preventDefault();
                    return;
                }
                switch (e.keyIdentifier) {
                    case 'U+0057' :
                    {
                        b2.setDir('Up', true);
                        e.preventDefault();
                        break;
                    }
                    case 'U+0044' :
                    {
                        b2.setDir('Right', true);
                        e.preventDefault();
                        break;
                    }
                    case 'U+0053' :
                    {
                        b2.setDir('Down', true);
                        e.preventDefault();
                        break;
                    }
                    case 'U+0041' :
                    {
                        b2.setDir('Left', true);
                        e.preventDefault();
                        break;
                    }
                }
            };
            document.onkeyup = function (e) {
                if (e.keyIdentifier == 'U+0020') {
                    clearInterval(halt);
                    halt = 0;
                    return;
                }
                if (typeof b.dir[e.keyIdentifier] !== 'undefined') {
                    b.setDir(e.keyIdentifier, false);
                    return;
                }

                /**
                 * Player 2
                 */
                if (e.keyIdentifier == 'Shift') {
                    clearInterval(halt2);
                    halt2 = 0;
                    return;
                }
                switch (e.keyIdentifier) {
                    case 'U+0057' :
                    {
                        b2.setDir('Up', false);
                        e.preventDefault();
                        break;
                    }
                    case 'U+0044' :
                    {
                        b2.setDir('Right', false);
                        e.preventDefault();
                        break;
                    }
                    case 'U+0053' :
                    {
                        b2.setDir('Down', false);
                        e.preventDefault();
                        break;
                    }
                    case 'U+0041' :
                    {
                        b2.setDir('Left', false);
                        e.preventDefault();
                        break;
                    }
                }
            };
            /**
             * Ustaw globalna petle
             */
            Ticker.addListener(tick);
            Ticker.setFPS(FRAMERATE);
            Ticker.useRAF = true;
        }
    };
}(window));