/**
 * @class Goal
 * @package window
 * @author Sebsatian Widelak
 */
var Goal = (function (window, undefined) {
    var
        /**
         * CreateJS
         */
            Stage = createjs.Stage,
        Text = createjs.Text,
        Shape = createjs.Shape,
        Ticker = createjs.Ticker,
        /***
         * Box2D
         */
            b2Vec2 = Box2D.Common.Math.b2Vec2,
        b2BodyDef = Box2D.Dynamics.b2BodyDef,
        b2Body = Box2D.Dynamics.b2Body,
        b2FixtureDef = Box2D.Dynamics.b2FixtureDef,
        b2Fixture = Box2D.Dynamics.b2Fixture,
        b2World = Box2D.Dynamics.b2World,
        b2MassData = Box2D.Collision.Shapes.b2MassData,
        b2PolygonShape = Box2D.Collision.Shapes.b2PolygonShape,
        b2CircleShape = Box2D.Collision.Shapes.b2CircleShape,
        b2DebugDraw = Box2D.Dynamics.b2DebugDraw,
        b2RevoluteJointDef = Box2D.Dynamics.Joints.b2RevoluteJointDef;

    /**
     * @param id
     * @param x
     * @param y
     * @param world
     * @param SCALE
     * @constructor Goal
     */
    function Goal(id, x, y, world, SCALE) {
        var me = this,
            fixDef = new b2FixtureDef,
            bodyDef = new b2BodyDef;
        me.SCALE = SCALE;
        me.world = world;
        me.view = new Shape();
        me.view
            .graphics
            .beginFill('white')
            .drawRect(x, y, 10, 100)
            .beginFill('white');
        /**
         * Gestosc (kg/m^2)
         * @type {number}
         */
        fixDef.density = 1;
        /**
         * wspolczynnik tarcia
         * @type {number}
         */
        fixDef.friction = .1
        /**
         * Ustawiamy typ ciala
         * @type {*}
         */
        bodyDef.type = b2Body.b2_staticBody;
        /**
         * Body definition
         * punktem poczatkowy dla b2D jest srodek
         * @type {number}
         */
        bodyDef.position.x = (x + 5) / SCALE;
        bodyDef.position.y = (y + 50) / SCALE;
        /**
         * Shape
         * @type {Box2D.Collision.Shapes.b2PolygonShape}
         */
        fixDef.shape = new b2PolygonShape();
        fixDef.shape.SetAsBox(5 / SCALE, 50 / SCALE);
        me.view.body = world.CreateBody(bodyDef);
        me.view.body.CreateFixture(fixDef);
        me.view.body.element_type = 'Goal';
        me.view.body.element_id = id;
        me.view.onTick = function (e) {
            tick.call(me, e, this);
        };
    }

    function tick(e, view) {

    }

    return Goal;
}(window));